//+------------------------------------------------------------------+
//|                                                HTM_Diff_TF_MA.mq4|
//|                                                                  |
//|                      by Hans Theo Mislisch aka genaja  27-06-2012|                                          |
//+------------------------------------------------------------------+


// Zeigt in den Standardeinstellungen, den EMA50 des H1 und H4 Charts
// im aktuellen Chart an. Also, z.B. den EMA200 und EMA800 im M15 Chart.
// Shows as default the EMA50 of H1 (red) and H4 chart (blue) at the current chart.


#property copyright "Code written by - Hans Theo Mislisch"

#property indicator_chart_window
#property indicator_buffers 2

#property indicator_color1 Red
#property indicator_color2 C'0,107,215'
#property indicator_width1 2
#property indicator_width2 2


// MA_Period1=200;  // EMA50 H1 im TF15
// MA_Period2=800;  // EMA50 H4 im TF15

extern int MA_Period1=50;
extern int MA_Timeframe1=60;
extern int MA_Period2=50;
extern int MA_Timeframe2=240;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];


int MA_Period120;
int MA_Period240;



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   
   MA_Period120=MA_Period1*MA_Timeframe1/Period(); // EMA 1 fr aktuellen TF berechnen
   MA_Period240=MA_Period2*MA_Timeframe2/Period(); // EMA 2 fr aktuellen TF berechnen
    
   
   
//----
   return(0);
  }

int deinit()
  {
   return(0);
  }

int start()
  {
   int i,j,limit,counted_bars=IndicatorCounted();
   
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   for(i=0; i<limit; i++){  
      ExtMapBuffer1[i]=iMA(NULL, 0, MA_Period120, 0,MODE_EMA,PRICE_CLOSE,i);
      ExtMapBuffer2[i]=iMA(NULL, 0, MA_Period240, 0,MODE_EMA,PRICE_CLOSE,i);
   }
   

   return(0);
  }
//+------------------------------------------------------------------+